import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Random;

/**
 * @author: pashka
 */
public class Tests {

    public static void main(String[] args) {

        printTest("..........", 3, 4);
        printTest("........", 3, 4);
        printTest("..._._....", 3);
        printTest(".X........", 3);

        System.out.println("Group 0: " + tn);

        printTest(13, 8);
        printTest(18, 9);
        printTest(17, 4);
        printTest(1, 1);
        printTest(20, 1);
        printTest(20, 10);
        printTest(20, 20);

        System.out.println("Group 1: " + tn);

        genEmpty(20);

        System.out.println("Group 2: " + tn);

        genEmpty(100);

        System.out.println("Group 3: " + tn);

        printTest("...._..._....", 3, 1, 1, 3);
        genWhite(100);
        System.out.println("Group 4: " + tn);

        printTest("...._X.....", 2, 2);
        printTest("...._X.....", 2, 3);
        printTest("....._X_.....", 1, 3, 1);
        genFull(100);

        System.out.println("Group 5: " + tn);

        genFull(5000);
        System.out.println("Group 6: " + tn);

        genFull(200000);
        genCornerTests(200000);
        System.out.println("Group 7: " + tn);
    }

    private static void genCornerTests(int n) {
        printTest(n, n);
        printTest(n, 1);
        int[] c = new int[Math.min((n + 1) / 2, 100)];
        Arrays.fill(c, 1);
        printTest(n - ((n + 1) % 2), c);
        Arrays.fill(c, (n / c.length) - 1);
        printTest(n - ((n + 1) % 2), c);
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < n; i++) sb.append("X");
        printTest(sb.toString(), n);
    }

    private static void genWhite(int maxn) {
        for (double i = 0.2; i < 1; i += 0.3) {
            for (double j = 0.2; j < 1; j += 0.3) {
                int n = maxn - random.nextInt(maxn / 5);
                int cc = (n + 1) / 2;
                double pw = 1.0 / Math.exp(j * Math.log(100));
                int c = (int) Math.round(Math.exp(i * Math.log(cc)));
                c = Math.max(c, 2);
                c = Math.min(c, 100);
                printRandom(n, c, 0, pw);
            }
        }
    }

    private static void genFull(int maxn) {
        for (double i = 0.2; i < 1; i += 0.3) {
            for (double j = 0.2; j < 1; j += 0.3) {
                for (double k = 0.2; k < 1; k += 0.3) {
                    int n = maxn - random.nextInt(maxn / 5);
                    int cc = (n + 1) / 2;
                    double pb = 1.0 / Math.exp(j * Math.log(100));
                    double pw = 1.0 / Math.exp(k * Math.log(100));
                    int c = (int) Math.round(Math.exp(i * Math.log(cc)));
                    c = Math.max(c, 2);
                    c = Math.min(c, 100);
                    printRandom(n, c, pb, pw);
                }
            }
        }
        genPerioded(maxn);
    }

    private static void genPerioded(int maxn) {
        int x;
        do
            x = random.nextInt((maxn - 4) / 8) + 1;
        while (x < 2 || x > 10);
        int L = ((maxn - 4) - 3 * (x - 1)) / x;
        int n = L * x + 3 * (x - 1);
        if (n > maxn) throw new RuntimeException();
        StringBuffer sb = new StringBuffer();
        sb.append("..");
        for (int i = 0; i < x; i++) {
            if (i > 0) {
                sb.append("_X_");
            }
            for (int j = 0; j < L; j++) sb.append('.');
        }
        sb.append("..");
        int[] c = new int[n];
        int cn = 0;
        for (int i = 0; i < x - 1; i++) {
            c[cn++] = 1;
            int t = random.nextInt((L + 1) / 3) + 1;
            if (t > 10) t = 10;
            for (int j = 0; j < t; j++) {
                c[cn++] = 2;
            }
            int s = 2 * t + (t - 1);
            while (s < L) {
                c[cn - 1 - random.nextInt(t)]++;
                s++;
            }
        }
        c[cn++] = 1;
        {
            int[] cc = new int[cn];
            System.arraycopy(c, 0, cc, 0, cn);
            c = cc;
        }
        printTest(sb.toString(), c);
    }

    private static void genEmpty(int maxn) {
        printTest(maxn, maxn / 20, maxn / 4, maxn / 20, maxn / 4, maxn / 10);
        printTest((int) (maxn * 0.9), (int) (maxn * 0.25), (int) (maxn * 0.25), (int) (maxn * 0.3));
        for (double i = 0.1; i < 1; i += 0.25) {
            int n = maxn - random.nextInt(maxn / 5);
            int cc = (n + 1) / 2;
            int cn = (int) Math.round(Math.exp(i * Math.log(cc)));
            cn = Math.max(cn, 2);
            int[] c = new int[cn];
            int e = Math.max(n / cn, cn);
            Arrays.fill(c, 1);
            int s = cn;
            while (s + e < n) {
                c[random.nextInt(cn)]++;
                s++;
            }
            printTest(n, c);
        }
        {
            int n = maxn - random.nextInt(maxn / 5);
            int c = n / 10;
            printRandom(n, c, 0, 0);
        }
        for (int i = 0; i < 3; i++) {
            int n = maxn / 2 + random.nextInt(maxn / 2);
            int q = n / 4 + random.nextInt(n / 4);
            int[] c = new int[q];
            Arrays.fill(c, 1);
            int s = q + q - 1;
            while (s < n) {
                c[random.nextInt(q)]++;
                s++;
            }
            printTest(n, c);
        }
        {
            int[] c = new int[maxn / 2];
            Arrays.fill(c, 1);
            printTest(maxn, c);
            printTest(maxn - 1, c);
        }
    }

    static Random random = new Random(123234248921313L);

    private static void printRandom(int l, int cn, double pb, double pw) {
        int[] c = new int[cn];
        boolean[] a = new boolean[l];
        int cc = cn * 2;
        int ccn = 0;
        for (int i = 0; i < l; i++) {
            if (random.nextInt(l + 1 - i) < cc) {
                cc--;
                a[i] = !(i != 0 && a[i - 1]);
                if (a[i]) {
                    c[ccn++] = 1;
                }
            } else {
                a[i] = (i != 0 && a[i - 1]);
                if (a[i]) {
                    c[ccn - 1]++;
                }
            }
        }
        StringBuffer s = new StringBuffer();
        for (int i = 0; i < l; i++) {
            if (a[i]) {
                if (random.nextDouble() < pb) {
                    s.append("X");
                } else {
                    s.append(".");
                }
            } else {
                if (random.nextDouble() < pw) {
                    s.append("_");
                } else {
                    s.append(".");
                }
            }
        }
        printTest(s.toString(), c);
    }


    static int tn = 0;

    private static void printTest(String s, int... C) {
        tn++;
        PrintWriter out;
        try {
            out = new PrintWriter("" + tn);
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        }
        out.println(s);
        printArray(out, C);
        out.close();
    }

    private static void printTest(int n, int... C) {
        StringBuffer s = new StringBuffer();
        for (int i = 0; i < n; i++) s.append(".");
        printTest(s.toString(), C);
    }

    private static void printArray(PrintWriter out, int[] a) {
        out.print(a.length);
        for (int i = 0; i < a.length; i++) {
            out.print(' ');
            out.print(a[i]);
        }
        out.println();
    }
}
